# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import _utilities, _tables


class FirewallRule(pulumi.CustomResource):
    cidrs: pulumi.Output[list]
    """
    the IP address of the other end (i.e. not your instance) to affect, or a valid network CIDR (defaults to being globally applied, i.e. 0.0.0.0/0).
    """
    direction: pulumi.Output[str]
    """
    will this rule affect ingress traffic
    """
    end_port: pulumi.Output[str]
    """
    The end port where traffic to be allowed.
    """
    firewall_id: pulumi.Output[str]
    """
    The Firewall id
    """
    label: pulumi.Output[str]
    """
    a string that will be the displayed name/reference for this rule (optional)
    """
    protocol: pulumi.Output[str]
    """
    This may be one of "tcp", "udp", or "icmp".
    """
    start_port: pulumi.Output[str]
    """
    The start port where traffic to be allowed.
    """
    def __init__(__self__, resource_name, opts=None, cidrs=None, direction=None, end_port=None, firewall_id=None, label=None, protocol=None, start_port=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a Civo Cloud Firewall Rule resource.
        This can be used to create, modify, and delete Firewalls Rules.
        This resource don't have an update option because the backend don't have the
        support for that, so in this case we use ForceNew for all object in the resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[list] cidrs: the IP address of the other end (i.e. not your instance) to affect, or a valid network CIDR (defaults to being globally applied, i.e. 0.0.0.0/0).
        :param pulumi.Input[str] direction: will this rule affect ingress traffic
        :param pulumi.Input[str] end_port: The end port where traffic to be allowed.
        :param pulumi.Input[str] firewall_id: The Firewall id
        :param pulumi.Input[str] label: a string that will be the displayed name/reference for this rule (optional)
        :param pulumi.Input[str] protocol: This may be one of "tcp", "udp", or "icmp".
        :param pulumi.Input[str] start_port: The start port where traffic to be allowed.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if cidrs is None:
                raise TypeError("Missing required property 'cidrs'")
            __props__['cidrs'] = cidrs
            if direction is None:
                raise TypeError("Missing required property 'direction'")
            __props__['direction'] = direction
            if end_port is None:
                raise TypeError("Missing required property 'end_port'")
            __props__['end_port'] = end_port
            if firewall_id is None:
                raise TypeError("Missing required property 'firewall_id'")
            __props__['firewall_id'] = firewall_id
            __props__['label'] = label
            if protocol is None:
                raise TypeError("Missing required property 'protocol'")
            __props__['protocol'] = protocol
            if start_port is None:
                raise TypeError("Missing required property 'start_port'")
            __props__['start_port'] = start_port
        super(FirewallRule, __self__).__init__(
            'civo:index/firewallRule:FirewallRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, cidrs=None, direction=None, end_port=None, firewall_id=None, label=None, protocol=None, start_port=None):
        """
        Get an existing FirewallRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[list] cidrs: the IP address of the other end (i.e. not your instance) to affect, or a valid network CIDR (defaults to being globally applied, i.e. 0.0.0.0/0).
        :param pulumi.Input[str] direction: will this rule affect ingress traffic
        :param pulumi.Input[str] end_port: The end port where traffic to be allowed.
        :param pulumi.Input[str] firewall_id: The Firewall id
        :param pulumi.Input[str] label: a string that will be the displayed name/reference for this rule (optional)
        :param pulumi.Input[str] protocol: This may be one of "tcp", "udp", or "icmp".
        :param pulumi.Input[str] start_port: The start port where traffic to be allowed.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["cidrs"] = cidrs
        __props__["direction"] = direction
        __props__["end_port"] = end_port
        __props__["firewall_id"] = firewall_id
        __props__["label"] = label
        __props__["protocol"] = protocol
        __props__["start_port"] = start_port
        return FirewallRule(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
