# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import _utilities, _tables


class Network(pulumi.CustomResource):
    cidr: pulumi.Output[str]
    """
    The block ip assigned to the network.
    """
    default: pulumi.Output[bool]
    """
    If is the default network.
    """
    label: pulumi.Output[str]
    """
    The Network label
    """
    name: pulumi.Output[str]
    """
    The name of the network.
    """
    region: pulumi.Output[str]
    """
    The region where the network was create.
    """
    def __init__(__self__, resource_name, opts=None, label=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a Civo Network resource. This can be used to create,
        modify, and delete Networks.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_civo as civo

        custom_net = civo.Network("customNet", label="test_network")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] label: The Network label
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if label is None:
                raise TypeError("Missing required property 'label'")
            __props__['label'] = label
            __props__['cidr'] = None
            __props__['default'] = None
            __props__['name'] = None
            __props__['region'] = None
        super(Network, __self__).__init__(
            'civo:index/network:Network',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, cidr=None, default=None, label=None, name=None, region=None):
        """
        Get an existing Network resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cidr: The block ip assigned to the network.
        :param pulumi.Input[bool] default: If is the default network.
        :param pulumi.Input[str] label: The Network label
        :param pulumi.Input[str] name: The name of the network.
        :param pulumi.Input[str] region: The region where the network was create.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["cidr"] = cidr
        __props__["default"] = default
        __props__["label"] = label
        __props__["name"] = name
        __props__["region"] = region
        return Network(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
